# postgresql_publication – Add, update, or remove PostgreSQL publication

New in version 2.9.

- Synopsis
- Requirements
- Parameters
- Notes
- See Also
- Examples
- Return Values
- Status

## Synopsis

- Add, update, or remove PostgreSQL publication.

## Requirements

The below requirements are needed on the host that executes this module.

- psycopg2

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
ca_cert string |  | Specifies the name of a file containing SSL certificate authority (CA) certificate(s). If the file exists, the server's certificate will be verified to be signed by one of these authorities. aliases: ssl_rootcert

cascade
boolean

Choices:
- no ←
- yes

Drop publication dependencies. Has effect with state=absent only.

db string |  | Name of the database to connect to and where the publication state will be changed. aliases: login_db
login_host string |  | Host running the database.
login_password string |  | The password used to authenticate with.
login_unix_socket string |  | Path to a Unix domain socket for local connections.
login_user string | Default: "postgres" | The username used to authenticate with.
name string / required |  | Name of the publication to add, update, or remove.
owner string |  | Publication owner. If owner is not defined, the owner will be set as login_user or session_role.
parameters dictionary |  | Dictionary with optional publication parameters. Available parameters depend on PostgreSQL version.
port integer | Default: 5432 | Database port to connect to. aliases: login_port

ssl_mode
string

Choices:
- allow
- disable
- prefer ←
- require
- verify-ca
- verify-full

Determines whether or with what priority a secure SSL TCP/IP connection will be negotiated with the server.
See https://www.postgresql.org/docs/current/static/libpq-ssl.html for more information on the modes.
Default of `prefer` matches libpq default.

state
string

Choices:
- absent
- present ←

The publication state.

tables list / elements=string |  | List of tables to add to the publication. If no value is set all tables are targeted. If the publication already exists for specific tables and tables is not passed, nothing will be changed. If you need to add all tables to the publication with the same name, drop existent and create new without passing tables.

## Notes

Note

- PostgreSQL version must be 10 or greater.
- The default authentication assumes that you are either logging in as or sudo’ing to the `postgres` account on the host.
- To avoid “Peer authentication failed for user postgres” error, use postgres user as a become_user.
- This module uses psycopg2, a Python PostgreSQL database adapter. You must ensure that psycopg2 is installed on the host before using this module.
- If the remote host is the PostgreSQL server (which is the default case), then PostgreSQL must also be installed on the remote host.
- For Ubuntu-based systems, install the postgresql, libpq-dev, and python-psycopg2 packages on the remote host before using this module.
- The ca_cert parameter requires at least Postgres version 8.4 and psycopg2 version 2.4.3.

## See Also

See also

CREATE PUBLICATION reference
  Complete reference of the CREATE PUBLICATION command documentation.
ALTER PUBLICATION reference
  Complete reference of the ALTER PUBLICATION command documentation.
DROP PUBLICATION reference
  Complete reference of the DROP PUBLICATION command documentation.

## Examples

    - name: Create a new publication with name "acme" targeting all tables in database "test".
      postgresql_publication:
        db: test
        name: acme

    - name: Create publication "acme" publishing only prices and vehicles tables.
      postgresql_publication:
        name: acme
        tables:
        - prices
        - vehicles

    - name: >
        Create publication "acme", set user alice as an owner, targeting all tables.
        Allowable DML operations are INSERT and UPDATE only
      postgresql_publication:
        name: acme
        owner: alice
        parameters:
          publish: 'insert,update'

    - name: >
        Assuming publication "acme" exists and there are targeted
        tables "prices" and "vehicles", add table "stores" to the publication.
      postgresql_publication:
        name: acme
        tables:
        - prices
        - vehicles
        - stores

    - name: Remove publication "acme" if exists in database "test".
      postgresql_publication:
        db: test
        name: acme
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
alltables boolean | if publication exists | Flag indicates that all tables are published.
exists boolean | always | Flag indicates the publication exists or not at the end of runtime. Sample: True
owner string | if publication exists | Owner of the publication at the end of runtime. Sample: alice
parameters dictionary | if publication exists | Publication parameters at the end of runtime. Sample: {'publish': {'insert': False, 'delete': False, 'update': True}}
queries string | always | List of executed queries. Sample: ['DROP PUBLICATION "acme" CASCADE']
tables list | if publication exists | List of tables in the publication at the end of runtime. If all tables are published, returns empty list. Sample: ['"public"."prices"', '"public"."vehicles"']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Loic Blot (@nerzhul) <loic.blot@unix-experience.fr>
- Andrew Klychkov (@Andersson007) <aaklychkov@mail.ru>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.